using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Zad_A
{
    class Program
    {
        static void Main(string[] args)
        {
            int n = int.Parse(Console.ReadLine());
            string[] s = Console.ReadLine().Split();
            int o = int.Parse(s[0]);
            int a = int.Parse(s[1]);
            int b = int.Parse(s[2]);
            int ab = int.Parse(s[3]);
            int t = 1;
            string[] g = new string[n];
            int [] k=new int[n];
            for (int i = 0; i < n; i++)
            {
                string []p= Console.ReadLine().Split();
                g[i] = p[0];
                k[i] = int.Parse(p[1]);
            }
            int[] o1 = new int[n];
            int[] a1 = new int[n];
            int[] b1 = new int[n];
            int[] ab1 = new int[n];
            for (int i = 0; i < n; i++)
            {
                if (g[i]=="O")
                {
                    if (o>=k[i])
                    {
                        o1[i] = k[i];
                        o -= k[i];
                        k[i] = 0;
                        
                    }
                    else
                    {
                        t = 0;
                        break;
                    }

                }
                if (g[i] == "A")
                {
                    if (a >= k[i])
                    {
                        a1[i] = k[i];
                        a -= k[i];
                        k[i] = 0;

                    }
                    else
                    {
                        a1[i] = a;
                        k[i] -= a;
                        a = 0;
                    }
                }
                if (g[i] == "B")
                {
                    if (b >= k[i])
                    {
                        b1[i] = k[i];
                        b -= k[i];
                        k[i] = 0;

                    }
                    else
                    {
                        b1[i] = b;
                        k[i] -= b;
                        b= 0;
                    }
                }
                if (g[i] == "AB")
                {
                    if (ab >= k[i])
                    {
                        ab1[i] = k[i];
                        ab -= k[i];
                        k[i] = 0;

                    }
                    else
                    {
                        ab1[i] = ab;
                        k[i] -= ab;
                        ab = 0;
                    }
                }

            }
                            for (int i = 0; i < n; i++)
            {
                if (g[i] == "A")
                {
                    if (o >= k[i])
                    {
                        o1[i] = k[i];
                        o -= k[i];
                        k[i] = 0;

                    }
                    else
                    {
                        t = 0;
                        break;
                    }
                }
                if (g[i] == "B")
                {
                    if (o >= k[i])
                    {
                        o1[i] = k[i];
                        o -= k[i];
                        k[i] = 0;

                    }
                    else
                    {
                        t = 0;
                        break;
                    }
                }

                            
            }

                            for (int i = 0; i < n; i++)
                            {
                                
                                if (g[i] == "AB")
                                {
                                    if (o>= k[i])
                                    {
                                        o1[i] = k[i];
                                        o -= k[i];
                                        k[i] = 0;

                                    }
                                    else
                                    {
                                        t = 0;
                                        break;
                                    }
                                }

                            }
                            string[] rez = new string[n];
                            if (t == 0)
                            {
                                Console.WriteLine("nemoguce");
                            }
                            else
                            {
                                Console.WriteLine("moguce");
                                for (int i = 0; i < n; i++)
                                {
                                    rez[i] = o1[i] + " " + a1[i] + " " + b1[i] + " " + ab1[i];
                                    Console.WriteLine(rez[i]);
                                }
                            }




        }
    }
}